/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010-2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

#include "kernel_impl.h"
#include "task.h"

/*
 *  g[XO}ÑftHg`
 */

#ifndef LOG_DSP_ENTER
	#define LOG_DSP_ENTER(tskidx)
#endif /* LOG_DSP_ENTER */

#ifndef LOG_DSP_LEAVE
	#define LOG_DSP_LEAVE(tskidx)
#endif /* LOG_DSP_ENTER */


extern const intptr_t	tinib_exinf[];			/* ^XN̊g */
extern const TASK    	tinib_task[];			/* ^XN̋NԒn */
extern const uint_t  	tinib_epriority[];		/* ^XN̎sDxi\j */

/* ֐̃vg^Cv錾 */
Inline bool_t primap_empty(void);
Inline bool_t primap_test(uint_t pri);
Inline uint_t primap_search(void);
Inline void primap_set(uint_t pri);
Inline void primap_clear(uint_t pri);
Inline uint_t bitmap_search(uint_t bitmap);


#ifdef TOPPERS_tskini

/*
 *  sԃ^XŇݗDx
 */
uint_t runtsk_curpri;

/*
 *  sԃ^XN̋NDx
 */
uint_t runtsk_ipri;

/*
 *  fBL[T[`̂߂̃rbg}bv
 */
volatile uint_t	ready_primap;

/*
 *  NvL[CÕrbg}bv
 */
uint_t	actque_bitmap;

/*
 *  ^XNfBXpb`NvtO
 */
bool_t	reqflg;

/*
 *  fBXpb`֎~
 */
bool_t	disdsp;

/*
 *  read_primap̏l
 */
extern const uint_t init_rdypmap;

#endif /* TOPPERS_tskini */

#ifdef TOPPERS_get_ipriself

/*
 *  ^XNID̋NDx擾(^XNReLXgp)
 */
uint_t
get_ipri_self(ID tskid)
{
	uint_t ipri;
	
	if(tskid != TSK_SELF)
	{
		ipri = (uint_t)((tskid) - TMIN_TSKID);
	}
	else
	{
		ipri = runtsk_ipri;
	}
	return ipri;
}

#endif /* TOPPERS_get_ipriself */

/*
 *  ^XNID̋NDx擾(^XNReLXgp)
 */
#ifdef TOPPERS_get_ipri

uint_t
get_ipri(ID tskid)
{
	return (uint_t)(tskid - TMIN_TSKID);
}

#endif /* TOPPERS_get_ipri */

/*
 *  rbg}bvT[`֐
 *
 *  bitmap1̃rbg̓CłʁiEĵ̂T[`C̃rb
 *  gԍԂDrbgԍ́Cŉʃrbg0ƂDbitmap0w
 *  Ă͂ȂȂD̊֐ł́Cbitmap8rbgł邱Ƃ肵C
 *  uint8_t^ƂĂD
 *
 *  rbgT[`߂vZbTł́CrbgT[`߂g悤
 *  ǂꍇD̂悤ȏꍇɂ́C^[Qbg
 *  ˑŃrbgT[`߂gbitmap_search`C
 *  OMIT_BITMAP_SEARCH}N`΂悢D܂CrbgT[`߂
 *  T[`tȂǂ̗RŗDxƃrbgƂ̑ΉύXꍇ
 *  ́CPRIMAP_BIT}N`΂悢D
 *
 *  ܂CWCuffsȂĈ悤ɒ`ĕWCu
 *  gǂ\D
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1U << (pri))
#endif /* PRIMAP_BIT */

#ifndef OMIT_BITMAP_SEARCH

static const uint8_t bitmap_search_table[] = { 0U, 1U, 0U, 2U, 0U, 1U, 0U,
												3U, 0U, 1U, 0U, 2U, 0U, 1U, 0U };

Inline uint_t
bitmap_search(uint_t bitmap)
{
	uint_t	n = 0U;

#if TMAX_TPRI != 8
	if ((bitmap & 0x00ffU) == 0U) {
		bitmap >>= 8U;
		n += 8U;
	}
#endif
	
	if ((bitmap & 0x0fU) == 0U) {
		bitmap >>= 4U;
		n += 4U;
	}
	return (n + bitmap_search_table[(bitmap & 0x0fU) - 1U]);
}

#endif /* OMIT_BITMAP_SEARCH */


/*
 *  NDxrbg}bv󂩂̃`FbN
 */
Inline bool_t
primap_empty(void)
{
	return (ready_primap == 0U);
}

/*
 *  w肵NDx̋NDxrbg}bvZbgĂ邩ǂ̃`FbN
 */
Inline bool_t
primap_test(uint_t pri)
{
	return ((ready_primap & PRIMAP_BIT(pri)) != 0U);
}

/*
 *  NDxrbg}bṽT[`
 */
Inline uint_t
primap_search(void)
{
	return bitmap_search(ready_primap);
}

/*
 *  NDxrbg}bṽZbg
 */
Inline void
primap_set(uint_t pri)
{
	ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  NDxrbg}bṽNA
 */
Inline void
primap_clear(uint_t pri)
{
	ready_primap &= ~PRIMAP_BIT(pri);
}

/*
 *  ōD揇ʃ^XÑT[`
 */

#ifdef TOPPERS_tsksched

uint_t
search_schedtsk(void)
{
	return primap_search();
}

#endif /* TOPPERS_tsksched */

#ifdef TOPPERS_tskdmt
/*
 *  w肵NDx̃^XNsłԂǂ̃eXg
 *
 */
bool_t
test_dormant(uint_t ipri)
{
	return !primap_test(ipri);
}

#endif /* TOPPERS_tskdmt */

/*
 *  ^XNǗW[̏
 */


#ifdef TOPPERS_tskini

void
initialize_task(void)
{
	/* NDxrbg}bv̏ */
	ready_primap = init_rdypmap;
	
	/* ^XNDx̏ */
	runtsk_curpri = TSKPRI_NULL;
	runtsk_ipri = TSKPRI_NULL;
	
	/* NvL[CȌ */
	actque_bitmap = 0U;
	
	/* ݋֎~tȌ */
	disdsp = false;
}

#endif /* TOPPERS_tskini */

/*
 *  ^XN̋N
 */

#ifdef TOPPERS_tskact

bool_t
make_active(uint_t ipri)
{
	bool_t dsp;
	
	primap_set(ipri);
	
	/* 
	 *  sԃ^XŇݗDxƈŎw肳ꂽ
	 *  NΏۃ^XN̏DxrCsԃ^XN
	 *  ύX邩肷D
	 *
	 *  sԃ^XNύXꍇ̓fBXpb`֎~ԂQƂD
	 */
	if(ipri < runtsk_curpri) {
		dsp = !disdsp;
	}
	else {
		dsp = false;
	}
	
	return dsp;
}

#endif /* TOPPERS_tskact */


/*
 *  ^XN̎s
 */

#ifdef TOPPERS_tskrun

void
run_task(uint_t ipri)
{
	uint_t next_pri;		/* ɎsJn^XN̋NDx */
	uint_t saved_ipri;		/* Ăяo^XN̏Dx */
	uint_t saved_curpri;	/* Ăяo^XŇݗDx */
	bool_t cont;
	
	/* ōD揇ʃ^XNsOɁCݎs̃^XŇݗDxƏDxۑ */
	next_pri = ipri;
	saved_ipri = runtsk_ipri;
	saved_curpri = runtsk_curpri;
	
	do {
		/* s^XŇݗDxsDxɐݒ肷 */
		runtsk_curpri = tinib_epriority[next_pri];
		runtsk_ipri = next_pri;
#ifndef _MSC_VER
		/* CPUbN */
		t_unlock_cpu();
		
		/* ^XNsJn */
		(*((TASK)(tinib_task[next_pri])))(tinib_exinf[next_pri]);
#else
		dispatch_task(next_pri);
#endif
		if (t_sense_lock()) {
			/*
			 *  CPUbNԂext_tskĂ΂ꂽꍇ́CCPUbN
			 *  Ă^XNID́CT[rXR[łCPU
			 *  bNȗ΂悢D
			 */
		}
		else {
			/*
			 *  t_lock_cpủdisdsp̐ݒ̂悤ɂȂ̂́C
			 *  CPUbNɍēxt_lock_cpuĂ΂Ȃ߂łD
			 */
			t_lock_cpu();
		}
		
		/* ݗDx}XN͑SԂ̂͂Ȃ̂ŁCȂ */
		
		/*
		 *  fBXpb`֎~Ԃext_tskĂ΂ꂽꍇ́CfBXpb
		 *  `ԂɂĂ^XNID
		 *
		 *	{͈ȉ̂悤ɋLqׂł邪Cɂdisdsp
		 *	falseɂ΂߁CPfalseɐݒ肷D
		 *
		 *		if (disdsp) {
		 *			disdsp = false;
		 *		}
		 */
		disdsp = false;
		
		/* rbg}bvNAD */
		primap_clear(next_pri);
		
		cont = false;
		
		/* ^XNNvL[CÕ`FbN */
		if (actque_test(next_pri)) {
			actque_clear(next_pri);
			(void) make_active(next_pri);
		}
		
		/* ꂩ̃^XNs\ԂɂȂĂ邩 */
		if(!primap_empty())
		{
			/* ߂^XŇݗDx荂NDx^XNNꂽ */
			next_pri = search_schedtsk();
			if(saved_curpri > next_pri)
			{
				cont = true;
			}
		}
	} while(cont);
	
	runtsk_curpri = saved_curpri;
	runtsk_ipri = saved_ipri;
}

#endif /* TOPPERS_tskrun */

/*
 *  ^XNfBXpb`
 */

#ifdef TOPPERS_tskdsp

void
dispatcher(void)
{
	do {
		if(!primap_empty()) {
			/* ^XN̊Jn */
			run_task(search_schedtsk());
		}
		else {
			idle_loop();
		}
	} while(true);
}

#endif /* TOPPERS_tsk_dsp */
